package body Paskma.Sorts is


   procedure Swap (
         A,                  
         B : in out Key_Type ) is 
      Temp : Key_Type;  
   begin
      Temp := A;
      A := B;
      B := Temp;
   end;
   pragma Inline(Swap);

   procedure Quick_Sort_Body (
         Vector : in out Vector_Type; 
         Left,                        
         Right  :        Integer      ) is 

      Run_Left,  
      Run_Right : Integer;  
      Pivot     : Key_Type;  
   begin
      if Left >= Right then
         return;
      end if;

      Pivot := Vector((Left + Right) /2);
      Run_Left := Left;
      Run_Right := Right;

      loop
         while Vector(Run_Left) < Pivot loop
            Run_Left := Run_Left + 1;
         end loop;

         while Vector(Run_Right) > Pivot loop
            Run_Right := Run_Right - 1;
         end loop;

         if Run_Left < Run_Right then
            Swap(Vector(Run_Left), Vector(Run_Right));
            Run_Left := Run_Left + 1;
            Run_Right := Run_Right - 1;
         elsif Run_Left = Run_Right then
            Run_Left := Run_Left + 1;
            Run_Right := Run_Right - 1;
            exit;
         elsif Run_Left > Run_Right then
            exit;
         end if;

      end loop;

      Quick_Sort_Body(Vector, Left, Run_Right);
      Quick_Sort_Body(Vector, Run_Left, Right);

   end;


   ---------------
   -- Qick_Sort --
   ---------------

   procedure Quick_Sort (
         Vector : in out Vector_Type ) is 
   begin
      Quick_Sort_Body(Vector, Vector'First, Vector'Last);
   end Quick_Sort;

end Paskma.Sorts;

