with Ada.Text_Io,
   Ada.Strings.Unbounded;
use Ada.Text_Io,
   Ada.Strings.Unbounded;

with Ada.Characters.Handling;

use Ada.Characters.Handling;


procedure Compare_Test is 

   function Compare (
         Command : String; 
         -- should be 1..n          
         Line : Unbounded_String ) 
     return Boolean is 

      Upper_Command : String (Command'range);  
      Upper_Line    : String (1 .. Length (Line));  
   begin
      Upper_Command := To_Upper(Command);
      Upper_Line := To_Upper(To_String(Line));

      return Upper_Command = Upper_Line(Upper_Command'range);

   exception

      when Constraint_Error =>
         return False;
   end;


   Result : Boolean;  
   A      : String  := "allo";  
   B      : String  := "allooooo";  
begin
   if Compare("allo", To_Unbounded_String("allooooo")) then
      Result := True;
   else
      Result := False;
   end if;

   if Result then
      Put_Line("ano");
   else
      Put_Line("ne");
   end if;
end;