with Gnat.Sockets,
   Statistics,
   Task_Id_Types;

use Gnat.Sockets,
   Statistics,
   Task_Id_Types;

private
package Ftp_Server.Session is

   task type Session_Task_Type is
      entry Start (
            A_Configuration            : Ftp_Configuration_Type;   
            Accept_On_Socket           : Socket_Type;              
            Parent_For_New_Sessions    : Parent_Shortcut_Type;     
            Some_Task_Id               : Task_Id_Type;             
            Store_Statiscs_Information : Statistics_Manager_Access ); 
   end Session_Task_Type;

   type Session_Task_Access is access Session_Task_Type; 

end Ftp_Server.Session;
