with Ada.Strings.Unbounded;

use Ada.Strings.Unbounded;

package Reply_Codes is

   Invalid_Reply_Code : exception;  

   type Reply_Code_Type is 
         (The_110, 
          The_120, 
          The_125, 
          The_150, 
          The_200, 
          The_202, 
          The_211, 
          The_212, 
          The_213, 
          The_214, 
          The_215, 
          The_220, 
          The_221, 
          The_225, 
          The_226, 
          The_227, 
          The_230, 
          The_231, 
          The_250, 
          The_257, 
          The_331, 
          The_332, 
          The_350, 
          The_421, 
          The_425, 
          The_426, 
          The_450, 
          The_451, 
          The_452, 
          The_500, 
          The_501, 
          The_502, 
          The_503, 
          The_504, 
          The_530, 
          The_532, 
          The_550, 
          The_551, 
          The_553); 

   function To_Integer (
         Code : Reply_Code_Type ) 
     return Integer; 

   function To_Reply_Code (
         Num : Integer ) 
     return Reply_Code_Type; 

   function Image (
         Code : Reply_Code_Type ) 
     return Unbounded_String; 

end Reply_Codes;