with Gnat.Sockets,
   Ada.Streams,
   Ada.Exceptions,
   Ada.Text_Io;

use Gnat.Sockets,
   Ada.Streams,
   Ada.Exceptions,
   Ada.Text_Io;

procedure Test_Receiver is 
   S,  
   Sx   : Socket_Type;  
   A,Ax : Sock_Addr_Type;  
   Buf  : Stream_Element_Array(1..800);  
   Last : Stream_Element_Offset;  
begin
   Initialize;
   Create_Socket(S);
   A.Port := 355;
   Bind_Socket(S, A);
   Listen_Socket(S);
   Put_Line("accepting");
   Accept_Socket(S, Sx, Ax);
   delay 1.0;
   close_socket(sx);
   --Receive_Socket(Sx, Buf, Last);
   Put_Line("received " & Integer'Image(Integer(Last)) & " bytes");
   Finalize;
exception
   when Event : others =>
      Put_Line(Exception_Information(Event));
end;