with Gnat.Sockets,
   Ada.Streams,
   Ada.Exceptions,
   Ada.Text_Io;

use Gnat.Sockets,
   Ada.Streams,
   Ada.Exceptions,
   Ada.Text_Io;

procedure Test_Sender is 
   S       : Socket_Type;  
   A       : Sock_Addr_Type;  
   Buffer  : Stream_Element_Array (1 .. 500_000);  
   Last    : Stream_Element_Offset;  
   Counter : Integer                             := 0;    
begin
   Initialize;
   A.Port := 355;
   A.Addr := Inet_Addr("127.0.0.1");
   Put_Line("address assigned");
   Create_Socket(S);
   Put_Line("socket created");
   Connect_Socket(S, A);
   Put_Line("socket connected");
   delay 5.0;
   for I in Buffer'range loop
      Counter := Counter +1;
      Send_Socket(S, Buffer(I..I), Last);
   end loop;
   Put_Line("sent " & Integer'Image(Integer(Last)) & " bytes");
   Close_Socket(S);
   Finalize;
exception
   when E : others =>
      Put_Line(Exception_Information(E) & integer'image(counter));
end;