with Ada.Streams.Stream_Io,
   Ada.Streams,
   Ada.Exceptions,
   Ada.Strings.Unbounded;

use Ada.Streams.Stream_Io,
   Ada.Streams,
   Ada.Exceptions,
   Ada.Strings.Unbounded;

procedure File_Stream_Tester is 

   function To_Stream (
         Buf : Unbounded_String ) 
     return Stream_Element_Array is 
      Result : Stream_Element_Array (1 .. Stream_Element_Offset (Length (Buf)));  
   begin
      for I in Result'range loop
         Result(I) := Character'Pos( Element(Buf, Integer(I-Result'First)+1) );
      end loop;
      return Result;
   end;


   File : File_Type;  
begin
   create(File, In_File, "testfile.txt");
   Set_Index(File, 10);
   Set_Mode(File, Out_File);
   Write(File, To_Stream(To_Unbounded_String("writen")));
   Close(File);
end;